-----------------------------------------------------------
-- Class 221 Script 
-----------------------------------------------------------

function Initialise() --Called once when sim first loads

	isDebugOn = false
	
	if isDebugOn then
		file = io.open("../railworks/Assets/JustTrains/Voyager/RailVehicles/Diesel/221/Default/Engine/debug"..gCoachLetter..".txt","w")
	end
	
	COMPAT_MSG_RPM = 22101 --Message ID for RPM
	COMPAT_MSG_START = 22104 --Message ID for startup/shutdown
	COMPAT_MSG_BLIND = 22105 --Message ID for blind position
	COMPAT_MSG_FAIL = 22106 --Message ID for engine failure
	COMPAT_MSG_TILT = 22107 --Message ID for tilt on/off
	COMPAT_MSG_BOOTSTATE = 22108 --Message ID for tilt on/off
	COMPAT_MSG_COLDSTART = 22110 --Message for cold start trigger
	COMPAT_MSG_TASSENABLED = 22111 --Message for cold start trigger
	COMPAT_MSG_TASSFAILED = 22112
	JT_SCENARIO_MESSAGE	= 101 --Message ID for scenario trigger points
	nRPMPrev = 0 --Previous RPM value

	isExpert = false
	isExpertChecked = false
	gDoorInterlockTimer = 0 --Countdown time for door interlock release
	isDoorsInterlocked = true --Door interlock controller
	isPlayerLoco = false --Is this the driven unit
	isPlayerConsist = false --Is this the driven consist
	isSlipping = false --Is the unit wheelslipping
	isEngineRunning = false --Engine running monitor
	isAWSTestInProgress = false --AWS test sequence
	isAWSTested = false --AWS test sequence completed
	gRunningTime = 0 --Time since unit initialised
	gpreviousSpeed = 0 --Previous frame speed (m/s)
	isDRASet = true --DRA monitor
	DSDDELAY = 60 --DSD alarm countdown timer
	gDSDCount = 0 --DSD alarm timer
	isDSDTriggered = false --DSD monitor
	isSafetyIsolated = false --DSD isolation monitor
	isKeyIn = false --Driver's key monitor
	isReverserDSDReset = true --DSD alarm reset when reverser 
	gLastReverserValue = 0 --Previous allowed reverser value
	gLastFrameReverserValue = 0 -- Reverser value from previous frame
	gReverserDSDTimer = 0 --Reserser neutral DSD test timer
	isConfigured = false
	wiperSpeed = 0
	wiperDirection = 0
	wiperSpeedB = 0
	wiperDirectionB = 0
	gWiperSpeedFactor = 2
	isHazardLights = false
	isHazardOn = false
	gHazardTimer = 0
	gCombinedControllerPosition = 0
	gThrottleSetting = 0
	gTargetRPM = 300
	gCurrentAmps = 0
	gMaxSafeThrottle = 0
	gWiperDelay = 0
	gBlindFrame = 0
	gLastRPM = 0
	gPassComWarnTimer = 0
	gPassComVehicle = 0
	gPassComResetTimer = 0
	gFireAlarmResetTimer = 0
	gFireVehicle = 0
	gTMSMode = 2
	gBootState = 145
	gBootStartTime = 0
	gLastKeyValue = 0
	gAnomalyFlashTimer = 0
	gVehicleNumber = 0
	gEmergencyBrakeTimer = 0
	isEmergencyBrake = false
	isBrakeFault = false
	gBrakeLeakFactor = 0
	gBrakeFaultResetTimer = 0
	isEmergencyStop = false
	gPaxSoundDelay = 1
	gPaxSoundTimer = 0

	
	gSlowSpeedNotch = 0
	gCurrentSpeed = 0
	gSlowSpeedSet = 1.34112 
	gSlowSpeedWaitTime = 0
	isSlowSpeedActive = false
	isPassComTriggered = false
	isPassComBrakeApplied = false
	isBrakeOverrideActive = false
	gBrakeOverrideTimer = 0
	gEmergencyBrakeStack = 0
	isFireAlarmTriggered = false
	isBooting = true
	isBISOn = true
	isColdStart = false
	
	gAnomaly = {}
    for i=1, 4 do
      gAnomaly[i] = 0
    end	

	gLastLogTime = 0

	gSpeedMPH = 0 --Current speed (mph)
	gSpeedMS = 0 --Current speed (m/s)
	gReverserPos = 0 --Current reverser position
	gCabThrottlePos = 0 --Current cab throttle position
	gSimThrottlePos = 0 --Current sim throttle position
	gLastThrottlePos = 0 --Previous throttle position
	
	RPM_IDLE = 300
	RPM_MAX = 1800
	
	PAX_SOUND_COUNT = 4

	--Wiper Sweeps
	FORWARD = 0
	BACKWARD = 1
	DELAY = 2
	
	--TMS Modes
	TMS_OFF = 0
	TMS_BOOTING = 1
	TMS_OVERVIEW = 2
	TMS_SCREENSAVER = 3
	
	--Boot Steps
	BOOT_COLD = 0
	BOOT_START = 1
	BOOT_ALARMS = 42
	BOOT_TMS_START = 30
	BOOT_TMS_L3 = 77
	BOOT_NRN = 86
	BOOT_TMS_READY = 145
	
	Call("BeginUpdate") --Start per-frame update function

	Call( "HazardLight:Activate", 0)
	SetLights ( 0, 0, 0, 0, 0, 1, 1 )
	
	
end

function OnConsistMessage ( msg, argument, direction ) --Handles messages from other vehicles



	-- send the message further down the consist
	Call ( "SendConsistMessage", msg, argument, direction );
	
	if not isPlayerLoco then --Only when non-driven loco
	
		if ( msg == COMPAT_MSG_RPM ) then
			SetControl ( "RPM", argument )
			SetControl ( "AudioRPM", argument )
		elseif ( msg == COMPAT_MSG_START ) then
			SetControl ( "Startup", argument )
		elseif ( msg == COMPAT_MSG_BLIND ) then
			for i = 0, 40 do
				if i == math.floor (argument + 0.5) then
					Call ( "ActivateNode", "blind"..i, 1 )
				else
					Call ( "ActivateNode", "blind"..i, 0 )
				end
			end
		end
	end
	
	if ( msg == COMPAT_MSG_FAIL ) then
	
		
		if argument - gCoachLetter == 0 then
		
		
				SetControl ( "Startup", 0 )
			Call ( "SetPowerProportion", 0, 0 )
			
		end		
		
	end

	
end

function OnControlValueChange ( name, index, value )

	if Call( "*:ControlExists", name, index ) then
		Call( "*:SetControlValue", name, index, value )
	end
	
end

function OnCameraEnter ( cabEndWithCamera, carriageCam )

	SaloonLights ( 1 )
	gPaxSoundDelay = 2
		
end

function OnCameraLeave ( )

	SaloonLights ( 0 )
		
end


--Update function updates every frame (use of 'time' needed to get smooth animations)
function Update( time )

	--Detect whether the player is driving this consist
	if Call( "GetIsPlayer" ) == 1 then
		isPlayerConsist = true
	else
		isPlayerConsist = false
	end
	--Set global variables for commonly used control values
	gCurrentSpeed = Call( "GetSpeed" )
	gSpeedMPH = GetControl ( "SpeedometerMPH" ) --Speed (MPH)
	gCurrentAmps = 	GetControl ( "Ammeter" )
	gCurrentRPM = GetControl ( "RPM" ) --Engine RPM
	gRunningTime = gRunningTime + time --Increment the running time
	
	--Get the speed in metres per second
	gSpeedMS = Call( "GetSpeed" )
	if gSpeedMS < 0 then
		gSpeedMS = gSpeedMS * -1
	end

	if not isConfigured then	
		InitialConfig (time)
	end

	DoorInterlock (time)

	ExhaustControl (time)
	
	if gCoachLetter == COACH_C then
		PaxSounds ( time )
	end
end 

function InitialConfig ( time )

	if gRunningTime > 0.5 and not isConfigured then
	
		for i = 1, 40 do
			Call ( "ActivateNode", "blind"..i, 0 )
		end
		
		if gCoachLetter == COACH_C then
			for i = 1, 16 do
			
				Call( "SaloonLight"..i..":Activate", 0)			
			
			end
		end
		
		isConfigured = true
	end		

end

function SaloonLights ( state )

		if gCoachLetter == COACH_C then
			for i = 1, 16 do
			
				Call( "SaloonLight"..i..":Activate", state )			
			
			end
		end

end

function PaxSounds ( time )

	i = ( math.random ( 100 ) / 100 )

	if gPaxSoundTimer > gPaxSoundDelay then
		SetControl ( "PaxAudioVolume", i + 0.3 )
		SetControl ( "PaxAudioTrigger", 1 )
		gPaxSoundTimer = 0
		gPaxSoundDelay = math.random ( 30 )
	else
		gPaxSoundTimer = gPaxSoundTimer + time
		SetControl ( "PaxAudioTrigger", 0 )
	end

end
		
function ExhaustControl (time)

	if GetControl ( "Startup" ) < 0.5 then
		SetControl ( "RPM", 0 )
	end		

	if GetControl ( "RPM" ) > gLastRPM and gLastRPM < 299 and gLastRPM > 75 then
		Call( "ScriptExhaustRev:SetEmitterActive", 1 )
	else
		Call( "ScriptExhaustRev:SetEmitterActive", 0 )
	end
	
	if GetControl ( "RPM" ) > 1600 and gSpeedMS < 0.5 then
		Call( "ScriptExhaustLoad:SetEmitterActive", 1 )
	else
		Call( "ScriptExhaustLoad:SetEmitterActive", 0 )
	end
	
	if gLastRPM > 1750 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 1 )
	elseif gLastRPM > 1650 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 1 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1550 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 1 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1450 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 1 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1350 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 1 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 1150 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 1 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 750 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 1 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 650 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 1 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	elseif gLastRPM > 250 then
		Call( "ScriptExhaustIdle:SetEmitterActive", 1 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	else
		Call( "ScriptExhaustIdle:SetEmitterActive", 0 )
		Call( "ScriptExhaust1:SetEmitterActive", 0 )
		Call( "ScriptExhaust2:SetEmitterActive", 0 )
		Call( "ScriptExhaust3:SetEmitterActive", 0 )
		Call( "ScriptExhaust4:SetEmitterActive", 0 )
		Call( "ScriptExhaust5:SetEmitterActive", 0 )
		Call( "ScriptExhaust6:SetEmitterActive", 0 )
		Call( "ScriptExhaust7:SetEmitterActive", 0 )
		Call( "ScriptExhaust8:SetEmitterActive", 0 )
	end

	gLastRPM = GetControl ( "RPM" )
	
end


function DoorInterlock (time)

	if (GetControl ( "DoorsOpenCloseLeft" ) > 0.99 or GetControl ( "DoorsOpenCloseRight" ) > 0.99) and isDoorsInterlocked then
		isDoorsInterlocked = false
		gDoorInterlockTimer = 0
	elseif (GetControl ( "DoorsOpenCloseLeft" ) < 0.01 and GetControl ( "DoorsOpenCloseRight" ) < 0.01) and isDoorsInterlocked == false then
		gDoorInterlockTimer = gDoorInterlockTimer + time
		if gDoorInterlockTimer > 17 then 
			isDoorsInterlocked = true
		end
	else 
		gDoorInterlockTimer = 0
	end
	
	if isDoorsInterlocked then
		Call ( "ActivateNode", "doorlights", 0 )
		Call( "InterlockLeft:Activate", 0)			
		Call( "InterlockRight:Activate", 0)			
	else
		Call ( "ActivateNode", "doorlights", 1 )
		Call( "InterlockLeft:Activate", 1)			
		Call( "InterlockRight:Activate", 1)			
	end

end
-- Function to set a named control to the correct value if the control exists - used to keep code compact.
function SetControl ( name, value )

	if Call( "*:ControlExists", name, 0 ) then
		Call( "*:SetControlValue", name, 0, value )
		return true
	else
		return false
	end

end

-- Function to get a named control value if the control exists - used to keep code compact.
function GetControl ( name )

	if Call( "*:ControlExists", name, 0 ) then
		return Call( "*:GetControlValue", name, 0 )
	else
		return 0
	end

end

-- Function to log to a debug file
function DebugFile ( message )

	local timehundredths = math.floor ( gRunningTime * 100 ) / 100

	if isDebugOn then
		file:write ( timehundredths..": "..message.."\n" )
	end
end
